.nolist	; ******************** CONSOLE assembly ********************
include \masm32\include\masm32rt.inc
include \masm32\macros\ucmacros.asm

wstrP	PROTO: DWORD, :DWORD
wstr MACRO argWide:REQ, args:VARARG
LOCAL argByte
.data
  argByte	db args
.data?
align 2
  argWide	dw SIZEOF argByte dup(?)
.code
  push offset argByte
  push offset argWide
  mov ecx, SIZEOF argWide
  call wstrP
;  invoke MultiByteToWideChar, CP_ACP, MB_PRECOMPOSED,
;  offset argByte, -1, offset argWide, LENGTHOF argWide
ENDM

wchr$ MACRO args:VARARG
LOCAL argByte, argWide
.data
  argByte	db args, 0
.data?
align 2
  argWide dw SIZEOF argByte dup(?)
.code
  push offset argByte
  push offset argWide
  mov ecx, SIZEOF argWide
  call wstrP
  sub ecx, SIZEOF argWide
  EXITM <offset argWide>
ENDM

.data
  ; fails miserably:
  ; WSTR wssh1, " Wouldn't it be", 13, 10, " nice if macros simply",13,10," worked as they should,", 13, 10, " instead of producing wrong sizes?"
  ; works, but produces wrong SIZEOF and LENGTHOF:
  WSTR wssh, " WSTR (SH): Wouldn't it beLF nice if macros simplyLF worked as they should,LF instead of producing wrong sizes?"

.code
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE 
wstrP proc Src:DWORD, Dest:DWORD	; substitute for MultiByteToWideChar
  push edi
  push esi
  mov edi, [esp+12]	; offset var
  mov esi, [esp+16]	; offset argByte
  xor eax, eax		; clear ah
  add ecx, edi		; dest offset plus byte count
  .Repeat
	lodsb
	stosw
  .Until edi>ecx
  pop esi
  pop edi
  ret
wstrP endp
LwstrP:	; label for calculating size
OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

start:

ws_in:
	wstr AppName, "Testing the wstr macro:", 0
ws_out:
	wstr wsjj, " wstr (JJ): Wouldn't it be", 13, 10, " nice if macros simply",13,10," worked as they should,", 13, 10, " instead of producing wrong sizes?", 0

	print chr$(13,10, "The size of the macro call: ")
	print str$(offset ws_out-ws_in)
	print chr$(13,10, "The size of the wstrP algo: ")
	print str$(offset LwstrP-wstrP),13,10,10

	invoke crt_printf, chr$("%S"), addr wsjj
	print chr$(13,10, 10,"  LENGTHOF wsJJ: ", 9)

	; REMOVED TRAILING COMMA, accepted by ML but rejected by JWasm:
	; print ustr$(LENGTHOF wsjj),9, "(including zero delimiter)", 13,10, 
	print ustr$(LENGTHOF wsjj),9, "(including zero delimiter)", 13,10
	print "  SIZEOF wsJJ:    ", 9
	print ustr$(SIZEOF wsjj),9, "(including zero delimiter)", 13, 10, 10, 10, 10

	invoke crt_printf, chr$("%S"), addr wssh	; one unicode string
	; invoke crt_printf, chr$("%S%c"), addr wssh	; one unicode, one ansi string
	print chr$(13,10, 10,"  LENGTHOF wsSH: ", 9)
	print ustr$(LENGTHOF wssh), 13,10
	print "  SIZEOF wsSH:    ", 9
	print ustr$(SIZEOF wssh), 13, 10, 10

	invoke MessageBoxW,0,wchr$("It would be great if",13,10,"macros simply did their job"),
	wchr$("Testing the wstr macro:"), MB_OK

	invoke MessageBox,0,chr$("It would be great if",13,10,"macros simply did their job"),
	chr$("Testing the wstr macro:"), MB_OK

    exit

end start
